/* common function */
function hasClass(elements, cName) {

    return !!elements.className.match(new RegExp("(\\s|^)" + cName + "(\\s|$)"));
};
function addClass(elements, cName) {
    if (!hasClass(elements, cName)) {
        elements.className += " " + cName;
    };
};
function removeClass(elements, cName) {
    if (hasClass(elements, cName)) {
        elements.className = elements.className.replace(new RegExp("(\\s|^)" + cName + "(\\s|$)"), " ");
    };
};
function toogleClass(elements, cName) {
    if (hasClass(elements, cName)) {
        removeClass(elements, cName);
    } else {
        addClass(elements, cName);
    }
}
function Selector(selector) {
    var tmp = selector.slice(1);
    if (selector.charAt(0) === '.') {
        return document.getElementsByClassName(tmp)[0];
    } else {
        return document.getElementById(tmp);
    }
}

var firstClick = true;
var commentFlag = true;
var timer;
var FunnyCommentCount = 1;
var woquTouch = "ontouchstart" in document.documentElement ? "touchend" : "click";


Selector('.xyx-menu-openbtn').addEventListener(woquTouch, function(event) {
    Selector('.xyx-Main-box').style.display = "block";
    TweenLite.to("#xyx-btn-box", 0.5, { left: "0" });
    if (firstClick) {
        var a = document.getElementById('xyx-scroll-box').scrollHeight + 17;
        var b = document.getElementById('xyx-btn-box').offsetHeight;
        if (a > b) {
            addClass(Selector('.xyx-bottom-tips'), 'xyx-bottom-tips-scroll');
        }
    }
    event.preventDefault();
    return true;
})

Selector('.xyx-fullscreen').addEventListener(woquTouch, function(event) {
    TweenLite.to("#xyx-btn-box", 0.5, { left: "-300", onComplete: function() { Selector('.xyx-Main-box').style.display = "none"; shareFlag = true; } });
    event.preventDefault();
    return true;
})

Selector('.xyx-showshareinfo').addEventListener(woquTouch, function(event) {
    if (hasClass(Selector('.xyx-menu-btnbox2'), "xyx-btnbox-open")) {
        removeClass(Selector('.xyx-menu-btnbox2'), "xyx-btnbox-open");
        var a = document.getElementById('xyx-scroll-box').scrollHeight + 17;
        var b = document.getElementById('xyx-btn-box').offsetHeight;
        if (a <= b) {
            removeClass(Selector('.xyx-bottom-tips'), 'xyx-bottom-tips-scroll');
        }
    } else {
        addClass(Selector('.xyx-menu-btnbox2'), "xyx-btnbox-open");
        var a = document.getElementById('xyx-scroll-box').scrollHeight + 17;
        var b = document.getElementById('xyx-btn-box').offsetHeight;
        if (a > b) {
            addClass(Selector('.xyx-bottom-tips'), 'xyx-bottom-tips-scroll');
        }
    }
    event.preventDefault();
    return true;
})

Selector('.xyx-share-b').addEventListener(woquTouch, function(event) {
    shareToWeixin();
    event.preventDefault();
    return true;
})
Selector('.xyx-share-c').addEventListener(woquTouch, function(event) {
    shareToQQ();
    event.preventDefault();
    return true;
})

Selector('.xyx-menu-btnbox3').addEventListener(woquTouch, function(event) {
    var u = navigator.userAgent, app = navigator.appVersion;
    var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
    if(isiOS){
        api.setStatusBarStyle({
            style: 'dark'
        });
    }
    api.closeToWin({
        name: 'root'
    });
    event.preventDefault();
    return true;
})

Selector('.xyx-menu-btnbox5').addEventListener(woquTouch, function(event) {
    api.openFrame({
        name: 'game_frame',
        url: framelink,
        rect: {
            x: 0,
            y: 20,
            w: 'auto',
            h: 'auto'
        },
        reload: true,
        bgColor: 'rgba(0,0,0,0)'
    });
    return true;
})
Selector('.xyx-menu-btnbox6').addEventListener(woquTouch, function(event) {
    api.execScript({
        name : 'PlayGame',
        script: 'closeGamewindow();'
    });
})

function initfunnyMainbox() {
    Selector('.xyx-Main-box').style.height = window.innerHeight + "px";
}
initfunnyMainbox();


var myToggle = document.getElementById("xyx-menu-openbtn");
var panel = document.getElementById("xyx-menu-box");
var isLowVersionMobile = false;
setTogglePos(1);

function setTogglePos(type) {
    switch (type) {
        case 1:
            if (!isLowVersionMobile) {
                myToggle.classList.add('upper-left');
            }
            break;
        case 2:
            if (!isLowVersionMobile) {
                myToggle.classList.remove('upper-left');
                myToggle.classList.add('upper-right');
            }
            break;
    }
}
function light(boolen) {
    if (boolen) {
        myToggle.style.opacity = "1";
    } else {
        myToggle.style.opacity = "0.5";
    }
}
var flag = false
function toggle() {
    if (!flag) {
        trigger();
    } else {
        cancel(event);
    }
}
function trigger() {
    light(true);
    flag = true;
    shareFlag = 0;
}
function cancel(event) {
    light(false);
    flag = false;
    setTimeout(function() {
        shareFlag = 1;
    }, 1000);
    event.preventDefault();
    return true;
}

function changeShare() {

}
/*  common function */
function ajaxGet(url, callback) {
    var xmlHttp = new XMLHttpRequest();
    xmlHttp.open("GET", url, true);
    xmlHttp.onreadystatechange = function() {
        if (xmlHttp.readyState == 4 && xmlHttp.status == 200) {
            callback && callback(xmlHttp.responseText);
        }
    }
    xmlHttp.send();
}
function ajaxPost(url, data, callback) {
    var postData = data;
    var xhr = new XMLHttpRequest();
    xhr.open("POST", url, true);
    xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    if (typeof(postData) === 'object') {
        postData = (function(obj) { // 转成post需要的字符串.
            var str = "";
            for (var prop in obj) {
                str += prop + "=" + obj[prop] + "&"
            }
            return str;
        })(postData);
    }
    xhr.onreadystatechange = function() {
        var XMLHttpReq = xhr;
        if (XMLHttpReq.readyState == 4) {
            if (XMLHttpReq.status == 200) {
                var text = XMLHttpReq.responseText;
                callback && callback(text);
            }
        }
    };
    xhr.send(postData);
}
var letter = document.getElementById("xyx-menu-letter");

function setTip() {
}

function clearTip() {
}

function updateRecord(score, data, fn) {
}

function updateStorage(data) {
}

function commonGameOver(score, propor, data, fn) {
    updateRecord(score, data, fn);
    createShare(score, propor);
}
function commonMoreGame() {
    var u = navigator.userAgent, app = navigator.appVersion;
    var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
    if(isiOS){
        api.setStatusBarStyle({
            style: 'dark'
        });
    }
    api.closeToWin({
        name: 'root'
    });
}
function createShare(score, propor) {
}

//platform judge and share
var isWeChat = false;
var isQQ = false;
var isWeibo = false;
function shareToWeixin(){
    var sharelink = shareData.link;
    var sharetitle = shareData.title;
    var sharedesc = shareData.desc;
    api.execScript({
        name : 'PlayGame',
        script: 'sharetowxsession("'+sharelink+'","'+sharetitle+'","'+sharedesc+'");'
    });
}
function shareToQQ() {
    var sharelink = shareData.link;
    var sharetitle = shareData.title;
    var sharedesc = shareData.desc;
    api.execScript({
        name : 'PlayGame',
        script: 'sharetoqq("'+sharelink+'","'+sharetitle+'","'+sharedesc+'");'
    });
}
function showShareTip() {
    shareFlag = false;
    Selector('.xyx-Main-box').style.display = "block";
    TweenLite.to("#xyx-btn-box", 0.5, { left: "0" });
}